<?php
/*
Plugin Name: Public Piwigo WordPress Widget
Version: auto
Description: Public Piwigo WordPress Widget (PW^2) is a WordPress 2.8 widget, it links a public picture in your Piwigo gallery (<a href="http://piwigo.org/">Piwigo</a>). In other words, it's a WordPress Sidebar Widget with some available public pictures in your Piwigo gallery as a prereq.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=
Author: VDigital
Author URI: http://www.vdigital.org/
*/
if (defined('PHPWG_ROOT_PATH')) return;

class Public_Piwigo_WordPress_Widget extends WP_Widget
{
    function Public_Piwigo_WordPress_Widget(){
      $widget_ops = array('classname' => 'Public_Piwigo_WordPress_Widget',
        'description' => __( "Adds a thumbnail and its link (to the picture) inside your blog sidebar.") );
      $control_ops = array('width' => 300, 'height' => 300);
      $this->WP_Widget('Public_Piwigo_WordPress_Widget', 'Public Piwigo WordPress Widget', $widget_ops, $control_ops);
    }

    function widget($args, $gallery){
      global $wpdb;
      extract($args);
      $title = apply_filters('widget_title', empty($gallery['title']) ? '&nbsp;' : $gallery['title']);
      $piwigo = empty($gallery['piwigo']) ? '' : $gallery['piwigo'];
      $piwigo_url = 'http://' . $_SERVER['HTTP_HOST'] . '/' . $piwigo ;
      if (!empty($gallery['external'])) $piwigo_url = $gallery['external'];
      if (substr($piwigo_url,-1)!='/') $piwigo_url .= '/';
      $options = '';
      if (!empty($gallery['category'])) $options = '&cat_id=' . intval($gallery['category']);

      $from = empty($gallery['from']) ? '12' : intval($gallery['from']);
      $r = (array) $wpdb->get_results('SELECT date_sub( date( now( ) ) , INTERVAL ' . $from . ' MONTH ) as begin');
      $from = $r[0]->begin;
      if (!empty($gallery['from'])) $options .= '&f_min_date_created=' . $from;

      $divclass = empty($gallery['divclass']) ? '' : ' class="' . $gallery['divclass'] .'"';
      $class = empty($gallery['class']) ? '' : ' class="' . $gallery['class'] .'"';

      echo $before_widget;
      if ( $title ) echo $before_title . $title . $after_title;

      # Make the Piwigo link
      $response = file_get_contents( $piwigo_url . 'ws.php?method=pwg.categories.getImages&format=php&per_page=1'
        . $options . '&recursive=true&order=random&f_with_thumbnail=true');
      $thumbc = unserialize($response);
      if ($thumbc["stat"] == 'ok') {
          $picture = $thumbc["result"]["images"]["_content"][0];
          echo '<div' . $divclass . '><a title="' . $title . '" href="' . $piwigo_url . 'picture.php?/' . $picture['id'] . '"><img '
            . $class . ' src="' . $picture['tn_url'] . '" alt="" /></a></div>';
      }

      echo $after_widget;
    }

    function update($new_gallery, $old_gallery){
      $gallery = $old_gallery;
      $gallery['title'] = strip_tags(stripslashes($new_gallery['title']));
      $gallery['piwigo'] = strip_tags(stripslashes($new_gallery['piwigo']));
      $gallery['external'] = strip_tags(stripslashes($new_gallery['external']));
      $gallery['category'] = intval(strip_tags(stripslashes($new_gallery['category'])));
      $gallery['from'] = intval(strip_tags(stripslashes($new_gallery['from'])));
      $gallery['divclass'] = strip_tags(stripslashes($new_gallery['divclass']));
      $gallery['class'] = strip_tags(stripslashes($new_gallery['class']));

    return $gallery;
    }

    function form($gallery){
      //Defaults
      $gallery = wp_parse_args( (array) $gallery, array('title'=>__('Random picture'), 
        'piwigo'=>'piwigo', 'external'=>'', 'category'=>0, 'from'=> 12, 'divclass'=>'', 'class'=>'', ) );

      $title = htmlspecialchars($gallery['title']);
      $piwigo = htmlspecialchars($gallery['piwigo']);
      $external = htmlspecialchars($gallery['external']);
      $category = intval($gallery['category']);
      $from = intval($gallery['from']);
      $divclass = htmlspecialchars($gallery['divclass']);
      $class = htmlspecialchars($gallery['class']);

      # Options
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('title') . '">' . __('Public Piwigo WordPress Widget Title:') 
      . ' <input style="width: 250px;" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title')
      . '" type="text" value="' . $title . '" /></label></p>';
      # Piwigo directory
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('piwigo') . '">' . __('Your Piwigo directory (local):') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('piwigo') . '" name="' . $this->get_field_name('piwigo')
      . '" type="text" value="' . $piwigo . '" /></label></p>';
      # Optional parameters
      echo '<h5>' . __('Piwigo optional parameters') . '</h5>';
      # External website
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('external') . '">' . __('Piwigo gallery URL (external):') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('external') . '" name="' . $this->get_field_name('external')
      . '" type="text" value="' . $external . '" /></label></p>';
      # Category
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('category') . '">' . __('Piwigo category id (0=all):') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('category') . '" name="' . $this->get_field_name('category')
      . '" type="text" value="' . $category . '" /></label></p>';
      # from
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('from') . '">' . __('for X months (empty=all):') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('from') . '" name="' . $this->get_field_name('from')
      . '" type="text" value="' . $from . '" /></label></p>';
      # divclass
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('divclass') . '">' . __('CSS DIV class:') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('divclass') . '" name="' . $this->get_field_name('divclass')
      . '" type="text" value="' . $divclass . '" /></label></p>';
      # class
      echo '<p style="text-align:right;"><label for="' . $this->get_field_name('class') . '">' . __('CSS IMG class:') 
      . ' <input style="width: 200px;" id="' . $this->get_field_id('class') . '" name="' . $this->get_field_name('class')
      . '" type="text" value="' . $class . '" /></label></p>';
    }

}

/**
  * Register Public Piwigo WordPress Widget
  */
  function Public_Piwigo_WordPress_Widget_Init() {
        register_widget('Public_Piwigo_WordPress_Widget');
  }
  add_action('widgets_init', 'Public_Piwigo_WordPress_Widget_Init');
?>
